/*
* TanKy Chess with Chat & alphabeta v.2.8.1 beta Modify by tomitank
* Date:2016.03.21.
* Modify:tomitank [Kuzmics Tamas]
* Contact:tomitank@freemail.hu , tanky.hu@gmail.com
* [^:]// .* regular search->comment del
*/

var nodes = 0; // search nodes
var boardPly = 0; // board ply
var moveCount = 0;  // Counter for number of moves
var EN_PASSANT = 0; // En passant
var g_startTime = 0; // findMove time
var maxEval = 2000000; // Infinity
var timeStop = false; // time cutoff
var bestMove = false; // Pc bestmove
var backgroundEngine; // Worker Enginge
var REPLACE_PIECE_TO = 0; // repalce piece
var nullPieceValue = [0,0]; // Piece Value (White, Black)
var backgroundEngineValid = true; // Worker Valid?
var maxSearchTime = 0; // max search time to alphabeta
var historyTable = new Array(32); // History Table
var searchKillers = new Array(3 * 64); // Killer heuristik


/* Following are a few var names defined for better code readability. */

var WHITE = 0x0;
var BLACK = 0x8;

var PAWN = 0x01;
var KNIGHT = 0x02;
var KING = 0x03;
var BISHOP = 0x05;
var ROOK = 0x06;
var QUEEN = 0x07;


// White pieces have their 4th bit = 0
var WHITE_PAWN = 0x01;
var WHITE_KNIGHT = 0x02;
var WHITE_KING = 0x03;
var WHITE_BISHOP = 0x05;
var WHITE_ROOK = 0x06;
var WHITE_QUEEN = 0x07;

// Black pieces have their 4th bit = 1
var BLACK_PAWN = 0x09;
var BLACK_KNIGHT = 0x0A;
var BLACK_KING = 0x0B;
var BLACK_BISHOP = 0x0D;
var BLACK_ROOK = 0x0E;
var BLACK_QUEEN = 0x0F;

var currentPlayer = WHITE;  // whose turn is it now?
var captureMat = [ 0, 1, 2, 8, 0, 3, 4, 5]; // Capture Material
var pawnPassed = [ 0, 5, 10, 20, 35, 60, 100, 200 ]; // Gyalog elorehaladasi pontjai
var pieceValue = [ 0, 100, 325, 20000, 0, 325, 550, 1000 ]; // 0, Gyalog, Huszar, Kiraly, 0, Futo, Bastya, Vezer (Kiralyno)
var EndGame_Mate = 1 * pieceValue[ROOK] + 2 * pieceValue[KNIGHT] + 2 * pieceValue[PAWN] + pieceValue[KING]; // Vegjatek ?
var kingPosition = ((0x4 << 8) | 0x74); // 16 bits to track King on each side by tomitank defaul >> Black: 4, White: 116
var castleRights = 0x3F; // 2 bits to track castling on Search (tomitank) & 4 bits to track castling on each side for both players

// Initial state
var CHESS_BOARD = [	BLACK_ROOK, BLACK_KNIGHT, BLACK_BISHOP, BLACK_QUEEN, BLACK_KING, BLACK_BISHOP, BLACK_KNIGHT, BLACK_ROOK, 0, 0, 0, 0, 0, 0, 0, 0,
					BLACK_PAWN, BLACK_PAWN, BLACK_PAWN, BLACK_PAWN, BLACK_PAWN, BLACK_PAWN, BLACK_PAWN, BLACK_PAWN, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0,	0, 0, 0, 0, 0, 0, 0, 0,
					WHITE_PAWN, WHITE_PAWN, WHITE_PAWN, WHITE_PAWN, WHITE_PAWN, WHITE_PAWN, WHITE_PAWN, WHITE_PAWN, 0, 0, 0, 0, 0, 0, 0, 0,
					WHITE_ROOK, WHITE_KNIGHT, WHITE_BISHOP, WHITE_QUEEN, WHITE_KING, WHITE_BISHOP, WHITE_KNIGHT, WHITE_ROOK, 0, 0, 0, 0, 0, 0, 0, 0 ];


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	function validateMove(from, to, currentPlayer) {
		if (isPseudoLegal(from, to, currentPlayer))
		{
			if (!checkAfterMove(from, to, currentPlayer)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	function isPseudoLegal(from, to, currentPlayer) {

		var fromPiece = CHESS_BOARD[from];
		var toPiece = CHESS_BOARD[to];

		if (!fromPiece) { // Moving an empty square?
			return false;
		}

		if (to & 0x88) { // moving to outside valid board?
			return false;
		}

		if ( (fromPiece & 0x8) ^ currentPlayer ) {  // not your turn?
			return false;
		}
		
		if (toPiece && (toPiece & 0x8) === currentPlayer) {  // cannot attack one of your own
			return false;
		}

		var pieceType = fromPiece & 0x07;

		if (pieceType === QUEEN) { // queen
			if ( (Math.abs(from - to) % 15 && Math.abs(from - to) % 17) &&	// bishop move
				((from & 0x0F) !== (to & 0x0F) && (from & 0xF0) !== (to & 0xF0))) {  // rook move
				return false;
			}
		}else if (pieceType === ROOK) { // rook
			if ( (from & 0x0F) !== (to & 0x0F) && (from & 0xF0) !== (to & 0xF0)  ) {  // move in a file or a rank
				return false;
			}
		}else if (pieceType === BISHOP) { // bishop
			if ( Math.abs(from - to) % 15 && Math.abs(from - to) % 17 ) {  // bishop can only move diagonally
				return false;
			}
		}else if (pieceType === KING) { // king
			var diff = Math.abs(from - to);
			var direction = from - to > 0 ? 0x0 : 0x1;

			if ( diff === 1  || diff === 15 || diff === 16 || diff === 17 ) {
				// valid
			}
			else if ( diff === 2 && ! toPiece && ! CHESS_BOARD[(direction ? from + 1 : from - 1)] ) // castling
			{
					if ((castleRights >> (currentPlayer/4 + direction)) & 1) // casling is available in this direction
					{ 
						if (isPseudoLegal(from + (direction ? 3 : -4), from + (direction ? 1 : -1), currentPlayer)) // rook can move
						{
							if (! isSquareUnderAttack(from, currentPlayer)) // king is not in check now
							{
								if (! checkAfterMove(from, from + (direction ? 1 : -1), currentPlayer)) // the next square is not in check
								{
									// valid <<<< MODIFIY: "if" separate bug fix & speed up by tomitank
								} else {
									return false;
								}
							} else {
								return false;
							}
						} else {
							return false;
						}
					} else {
						return false;
					}
			} else {
				return false;
			}
		} else if (pieceType === KNIGHT) { // knight
			var diff = Math.abs(from - to);
			if ( diff !== 14  && diff !== 18 && diff !== 31 && diff !== 33 ) {
				return false;
			}
		} else if (pieceType === PAWN) { // pawn
			var direction = from - to > 0 ? 0x0 : 0x8;
			var diff = Math.abs(from - to);
			var fromRow = from & 0x70;

			if ( direction !== currentPlayer ) { // a pawn can only move forward
				return false;
			}

			if (EN_PASSANT == 0) // En passant by tomitank
			{
				var en_passant_diff = 0; // En passant not valid
			}
			else
			{
				var en_passant_diff = Math.abs(from - EN_PASSANT); // En passant valid
				var enpassant_direc = direction ? (diff === 17 ? from+1 : from-1) : (diff === 17 ? from-1 : from+1);
				var En_passat_valid = CHESS_BOARD[enpassant_direc];
			}

			if (diff === 16 && !toPiece) {  // single move forward?
				// valid
			} else if (diff === 32 && (fromRow === 0x60 || fromRow === 0x10) && !toPiece && !CHESS_BOARD[from + (direction ? 16 : -16)]) {  // double move from start
				// valid
			} else if ((diff === 15 || diff === 17) && toPiece) { // enemy hit
				// valid
			} else if ((en_passant_diff === 15 || en_passant_diff === 17) && !toPiece && EN_PASSANT === to && EN_PASSANT > 0 && fromPiece !== En_passat_valid) { // En passant by tomitank
				// valid en passant
			} else {
				return false;
			}
		}

		if (fromPiece & 0x04) { // sliding piece
			var diff = to - from;
			var step;

			if (diff % 17 === 0) {
				step = 17;
			}else if (diff % 15 === 0) {
				step = 15;
			}else if (diff % 16 === 0) {
				step = 16;
			}else{
				step = 1;
			}

			var iterations = diff/step;
			if (iterations < 0) {
				step = -step;
				iterations = -iterations;
			}

			var path = from + step;
			for (var i = 1; i < iterations; i++, path+=step) {
				if (CHESS_BOARD[path]) {
					return false;
				}
			}
		}

		return true;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


/*
	Makes a move on the board.
	This function is called only if the move is a valid move.
	This method takes care of moving the pieces on the board and
	setting any other variables like castlerights.
*/

	function makeMove(from, to, check) {

		var PAWN_REPLACE_BUG_FIX = CHESS_BOARD[from];
		var capturedPiece = CHESS_BOARD[to];


		// PAWN replace Live by tomitank
		if ((CHESS_BOARD[from] & 0x07) === PAWN && REPLACE_PIECE_TO != 0 && !check && (to < 8 || to >= 112))
		{
			CHESS_BOARD[from] = REPLACE_PIECE_TO;
			REPLACE_PIECE_TO = 0;
		}
		// PAWN replace Check by tomitank
		else if ((CHESS_BOARD[from] & 0x07) === PAWN && REPLACE_PIECE_TO == 0 && !check && (to < 8 || to >= 112))
		{
			if (CHESS_BOARD[from] === WHITE_PAWN)
			CHESS_BOARD[from] = WHITE_QUEEN;
			else
			CHESS_BOARD[from] = BLACK_QUEEN;
		}


		// Board update
		CHESS_BOARD[to] = CHESS_BOARD[from];
		CHESS_BOARD[from] = 0;	


		// En passant step check & enemy Pawn destroy by tomitank
		if ((CHESS_BOARD[to] & 0x07) === PAWN && EN_PASSANT === to && EN_PASSANT > 0  && !capturedPiece)
		{
			if (from - to > 0)	// enemy pawn poz -> en passant + or - 1
			var enemy_pawn_poz = (EN_PASSANT + 16);
			else
			var enemy_pawn_poz = (EN_PASSANT - 16);

			CHESS_BOARD[enemy_pawn_poz] = 0; // enemy destroy
		}


		// Hack to remember castleRights so that we don't
		// have to use a stack to keep track of it.
		// MODIFY: Remember to pawn replace and en passant added by tomitank!! (22 bits)
		var stateData = ((((((capturedPiece << 4) | PAWN_REPLACE_BUG_FIX) << 6) + castleRights) << 8) | EN_PASSANT);


		// En passant Set added by tomitank
		if ((CHESS_BOARD[to] & 0x07) === PAWN && ( Math.abs(from - to) === 32 ) 
		&& ((((CHESS_BOARD[to-1] & 0x07) === PAWN) && (CHESS_BOARD[to] !== CHESS_BOARD[to-1]))
			|| (((CHESS_BOARD[to+1] & 0x07) === PAWN) && (CHESS_BOARD[to] !== CHESS_BOARD[to+1]))) )
		{
			var en_passant_square = ((from - to) > 0 ? 16 : -16); // elojeles differencia
			EN_PASSANT = (to + en_passant_square); // En passant set
		}
		else
		{
			EN_PASSANT = 0; // En passant unset
		}



		// Castling & King position
		if ((CHESS_BOARD[to] & 0x07) === KING)
		{
			//  King-moves reset both castling bits per side.
			castleRights &= ~(3 << (currentPlayer/4));
			
			// King position update
			kingPosition = ((kingPosition & (currentPlayer ? 0x00FF : 0xFF00)) | (to << currentPlayer));

			// move rook too if it is a castling move
			if ( Math.abs(from - to) === 2 ) {
				var rookTo = from + (from > to ? -1 : 1);
				var rookFrom = from + (from > to ? -4 : 3);
				castleRights &= ~(16 << currentPlayer/8); // Search castling reset

				CHESS_BOARD[rookTo] = CHESS_BOARD[rookFrom];
				CHESS_BOARD[rookFrom] = 0;
			}
		}


		// Rook-move resets castling in that side
		if ((CHESS_BOARD[to] & 0x07) === ROOK)
		{
			if (from === 0x0 || from === 0x70) {
				var direction = 0;
				castleRights &= ~(1 << (currentPlayer/4 + direction));
			} else if (from === 0x7 || from === 0x77) {
				var direction = 1;
				castleRights &= ~(1 << (currentPlayer/4 + direction));
			}
		}


		// Capture of rook resets castling in that side
		if ( (capturedPiece & 0x07) === ROOK )
		{
			if (to === 0x0 || to === 0x70) {
				var direction = 0;
				var otherPlayer = currentPlayer ? 0 : 8;
				castleRights &= ~(1 << (otherPlayer/4 + direction));
			} else if (to === 0x7 || to === 0x77) {
				var direction = 1;
				var otherPlayer = currentPlayer ? 0 : 8;
				castleRights &= ~(1 << (otherPlayer/4 + direction));
			}
		}

		currentPlayer = currentPlayer ? 0 : 8;

		moveCount++;
		boardPly++;

		return stateData;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


/*
	Reverts ALL changes made by makeMove
	Added pawn replace and en passant by tomitank
*/

	function unMakeMove(from, to, stateData) {

		CHESS_BOARD[from] = (stateData >> 14) & 0xF;
		CHESS_BOARD[to] = (stateData >> 18) & 0xF;
		castleRights = (stateData >> 8) & 0x3F;
		EN_PASSANT = stateData & 0xFF;

		// undo en passant by tomitank
		if ((CHESS_BOARD[from] & 0x07) === PAWN && EN_PASSANT === to && EN_PASSANT > 0)
		{
			if (from - to > 0)	// enemy pawn poz -> en passant + or - 1
			var enemy_pawn_poz = (EN_PASSANT + 16);
			else
			var enemy_pawn_poz = (EN_PASSANT - 16);

			// undo enemy
			if (CHESS_BOARD[from] === WHITE_PAWN)
			CHESS_BOARD[enemy_pawn_poz] = BLACK_PAWN;
			else
			CHESS_BOARD[enemy_pawn_poz] = WHITE_PAWN;
		}


		// undo castling & King position
		if ( (CHESS_BOARD[from] & 0x07) === KING)
		{
 			// King position update
			kingPosition = ((kingPosition & (currentPlayer ? 0xFF00 : 0x00FF)) | (from << (currentPlayer ? 0 : 8)));

			// undo castling
			if (Math.abs(from - to) === 2)
			{
				var rookTo = from + (from > to ? -1 : 1);
				var rookFrom = from + (from > to ? -4 : 3);

				CHESS_BOARD[rookFrom] = CHESS_BOARD[rookTo];
				CHESS_BOARD[rookTo] = 0;
			}
		}

		currentPlayer = currentPlayer ? 0 : 8;

		moveCount--;
		boardPly--;

		return true;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	function checkAfterMove(from, to, currentPlayer) {
		var stateData = makeMove(from, to, true);

		// Find my king Modify by tomitank
		var kingPos = ((kingPosition >> currentPlayer) & 0xFF);

		if ((CHESS_BOARD[kingPos] & 0x07) !== KING) { // Bug fix >> player vs player
			for( var i = 0 ; i < 128 ; i++ ){
				if(CHESS_BOARD[i] === (currentPlayer ? BLACK_KING : WHITE_KING) ){
					var kingPos = i;
					break;
				}
			}
		}

		if ((CHESS_BOARD[kingPos] & 0x07) !== KING) { // King is dead
			return true;
		}

		var isKingUnderAttack = isSquareUnderAttack(kingPos, currentPlayer);
		unMakeMove(from, to, stateData, true);
		return isKingUnderAttack;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


/*
	Important Note: This fn cannot be used to check attacks on empty squares
	as of now since pawn captures to empty squares will not validate (todo: fix this)
	Added currentPlayer to if (faster search)->>by tomitank
*/
	function isSquareUnderAttack(square, currentPlayer, nullMove) {

		if (nullMove) { // Babuk osszerteke nullazas
			nullPieceValue[currentPlayer / 8] = 0;
		}

		for ( var i = 0; i < 128; i++ ) {
			if (nullMove && CHESS_BOARD[i] && ((CHESS_BOARD[i] & 0x8) === currentPlayer)) { // to nullMove
				nullPieceValue[currentPlayer / 8] += pieceValue[CHESS_BOARD[i] & 0x07]; // Babuk erteke
			}
			if (CHESS_BOARD[i] && ((CHESS_BOARD[i] & 0x8) === (currentPlayer ? 0 : 8))) { // King is under attack ?
				if (isPseudoLegal(i, square, currentPlayer ? 0 : 8)) {
					return true;
				}
			}
		}
		return false;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	function GameOver() {

			for (var from_index = 0; from_index < 128; from_index++)
			{
				if (CHESS_BOARD[from_index] && ((CHESS_BOARD[from_index] & 0x8) === currentPlayer)) // AKI EPP LEPHET
				{
					for (var next_index = 0; next_index < 128; next_index++)
					{
						if (validateMove(from_index, next_index, currentPlayer))
						{
							return false; // nincs vege
						}
					}
				}
			}

			return true;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	function Evaluation() {

			var Score = 0;
			var WhiteMate = 0;
			var BlackMate = 0;
			var WhitePieces = [];
			var BlackPieces = [];
			var WhitePawns = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
			var BlackPawns = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0];

		// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

		// Babuk inicializalasa
			for (var i = 0; i < 128; i++)
			{
				if (CHESS_BOARD[i] && (CHESS_BOARD[i] & 0x8) === WHITE) { // FEHER OLDAL

					if (CHESS_BOARD[i] === WHITE_PAWN) { // Feher gyalogok mentese oszloponkent

						var sor = tableRanks[i];
						var oszlop = tableFiles[i];

						if (WhitePawns[oszlop] === 0) { // Ha meg nem volt mentve gyalog az adott oszlopba
							WhitePawns[oszlop] = sor;
						} else {
							WhitePawns[oszlop] = WhitePawns[oszlop] < sor ? sor : WhitePawns[oszlop]; // A leghatso Feher gyalog >> sor szerinti pozicio mentese
						}

					}

					WhitePieces.push(i); // Feher babuk
					WhiteMate += pieceValue[CHESS_BOARD[i] & 0x07]; // Feher babuk erteke

				} else if (CHESS_BOARD[i] && (CHESS_BOARD[i] & 0x8) === BLACK) { // FEKETE OLDAL

					if (CHESS_BOARD[i] === BLACK_PAWN) { // Fekete gyalogok mentese oszloponkent

						var sor = tableRanks[i];
						var oszlop = tableFiles[i];

						if (BlackPawns[oszlop] === 0) { // Ha meg nem volt mentve gyalog az adott oszlopba
							BlackPawns[oszlop] = sor;
						} else {
							BlackPawns[oszlop] = BlackPawns[oszlop] > sor ? sor : BlackPawns[oszlop]; // A leghatso Fekete gyalog >> sor szerinti pozicio mentese
						}

					}

					BlackPieces.push(i); // Fekete babuk
					BlackMate += pieceValue[CHESS_BOARD[i] & 0x07]; // Fekete babuk erteke

				}
			}

		// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			if(WhiteMate == 20000 && BlackMate == 20000) { // Dontetlen
				return 0;
			}

		// Babuk ertekelese
			Score = WhiteMate - BlackMate;
			Score += PieceEval(WhitePieces, WhitePawns, BlackPawns, 0, WhiteMate); // Feher
			Score -= PieceEval(BlackPieces, BlackPawns, WhitePawns, 8, BlackMate); // Fekete

		// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			if (currentPlayer === WHITE) {
				return Score;
			} else {
				return -Score;
			}
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	function PieceEval(Pieces, friendPawns, enemyPawns, currentPlayer, Mate_Value) {

			var Score = 0; // Pozicio pont
			var bishopPair = 0; // Futo par

		// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

		// Tabla bejarasa minde egyes babuval
			for (var i = 0; i < Pieces.length; i++)
			{
				var piece = Pieces[i]; // Babu mezo
				var position = currentPlayer === BLACK ? tableMirror[piece] : piece; // Fekete / Feher


				if ((CHESS_BOARD[piece] & 0x07) === QUEEN) { // Vezer kulon ertekelese

						var sor = tableRanks[piece];
						var oszlop = tableFiles[piece];

						if (friendPawns[oszlop] === 0) { // Ha nincs az oszlopban sajat gyalog
							if (enemyPawns[oszlop] === 0) { // Ha ellenfel gyalog sincs az oszlopban
								Score += 5; // 7;
							} else {
								Score += 3; // 4;
							}
						}

						Score += queenMask[position]; // Pozicio pontozas

				} else if ((CHESS_BOARD[piece] & 0x07) === ROOK) { // Bastya kulon ertekelese

						var sor = tableRanks[piece];
						var oszlop = tableFiles[piece];

						if (friendPawns[oszlop] === 0) { // Ha nincs az oszlopban sajat gyalog
							if (enemyPawns[oszlop] === 0) { // Ha ellenfel gyalog sincs az oszlopban
								Score += 10; // 15;
							} else {
								Score += 5; // 7;
							}
						}

						Score += rookMask[position]; // Pozicio pontozas

				} else if ((CHESS_BOARD[piece] & 0x07) === BISHOP) { // Futo kulon ertekelese
						
						bishopPair++; // Futok szama

						Score += bishopMask[position]; // Pozicio pontozas

				} else if ((CHESS_BOARD[piece] & 0x07) === KNIGHT) { // Huszar kulon ertekelese

						Score += knightMask[position]; // Pozicio pontozas

				} else if ((CHESS_BOARD[piece] & 0x07) === KING) { // Kiraly kulon ertekelese

						if (((castleRights >> currentPlayer/4) & 3) === 0 && ((castleRights >> (4 + currentPlayer/8)) & 1) === 1) { // Sancolas elmulasztasa
							Score -= 10;
						}

						Score += Mate_Value <= EndGame_Mate ? kingEndMask[position] : kingMask[position]; // Pozicio pontozas (Vegjatek : Nyitas-Kozepjatek)

				} else if ((CHESS_BOARD[piece] & 0x07) === PAWN) { // Gyalog kulon ertekelese

						var sor = tableRanks[piece];
						var oszlop = tableFiles[piece];
						var diff = currentPlayer ? 16 : -16;

						if (friendPawns[oszlop - 1] === 0 && friendPawns[oszlop + 1] === 0) { // Elkulonitett gyalog negativ pont
							Score -= 10; // 15;
						}

						if (CHESS_BOARD[piece] !== CHESS_BOARD[piece + diff]) { // Ha nem Dupla gyalog

							if (currentPlayer === BLACK // Fekete Gyalog elore mozgas Szorgalmazasa
							&& (enemyPawns[oszlop] <= sor || enemyPawns[oszlop] === 0) // Nincs elottunk ellenseges Gyalog
							&& (enemyPawns[oszlop - 1] <= sor || enemyPawns[oszlop - 1] === 0) // Nincs mellettunk ellenseges Gyalog
							&& (enemyPawns[oszlop + 1] <= sor || enemyPawns[oszlop + 1] === 0)) { // Nincs mellettunk ellenseges Gyalog
								Score += pawnPassed[sor];
							} else if (currentPlayer === WHITE // Feher Gyalog elore mozgas Szorgalmazasa
							&& (enemyPawns[oszlop] >= sor || enemyPawns[oszlop] === 0) // Nincs elottunk ellenseges Gyalog
							&& (enemyPawns[oszlop - 1] >= sor || enemyPawns[oszlop - 1] === 0) // Nincs mellettunk ellenseges Gyalog
							&& (enemyPawns[oszlop + 1] >= sor || enemyPawns[oszlop + 1] === 0)) { // Nincs mellettunk ellenseges Gyalog
								Score += pawnPassed[7 - sor];
							}

						}

						Score += pawnMask[position]; // Pozicio pontozas
				}

			}

			if (bishopPair >= 2) { // Futo par plusz pont
				Score += 30;
			}

			// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			return Score;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	// Osszes lehetseges lepes
	function GenerateAllMoves(firstMove) {

		var AllMoves = []; // Lepesek tomb

		// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

		// Tabla bejarasa
		for (var from_index = 0; from_index < 128; from_index++)
		{
			if (CHESS_BOARD[from_index] && (CHESS_BOARD[from_index] & 0x8) === currentPlayer) // AKI EPP LEPHET
			{
				for (var next_index = 0; next_index < 128; next_index++)
				{
					if (isPseudoLegal(from_index, next_index, currentPlayer))
					{
						var Score = 0; // Lepes pont

						if (CHESS_BOARD[next_index] && (CHESS_BOARD[next_index] & 0x8) !== currentPlayer) { // Ha ellenfelet tudunk leutni

							var toPiece = captureMat[CHESS_BOARD[next_index] & 0x07];
							var fromPiece = captureMat[CHESS_BOARD[from_index] & 0x07];

							Score = 65024 + (toPiece - fromPiece); // 0xFE00 + kulonbseg

						} else if ((CHESS_BOARD[from_index] & 0x07) === PAWN) { // GYALOG

							if (next_index === EN_PASSANT)  { // En Passant lepes
								Score = 65024; // 0xFE00
							}

						} else { // URES MEZO

							if(searchKillers[boardPly] == ((CHESS_BOARD[from_index] << 4) | next_index)) { // Gyilkos lepes 1.
								Score = 61440; // 0xF000
							} else if(searchKillers[64 + boardPly] == ((CHESS_BOARD[from_index] << 4) | next_index)) { // Gyilkos lepes 2.
								Score = 57344; // 0xE000;
							} else {
								Score = historyTable[CHESS_BOARD[from_index]][next_index]; // Elozmeny tabla alapjan
							}

						}

						AllMoves.push((((from_index << 8) | next_index) << 16) | Score);  // 32 biten taroljuk a lepest max pont: 65535 (0xFFFF)

					}
				}
			}
		}

		// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

		// Rendezes lepes szint szerint
		AllMoves.sort(function(a, b) {
			var a_elem = a & 0xFFFF; // lepes szint a elem
			var b_elem = b & 0xFFFF; // lepes szint b elem
			return a_elem == b_elem ? 0 : a_elem > b_elem ? -1 : 1;
		});

		return AllMoves;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	// Utes lepesek
	function GenerateCaptures() {

		var AllMoves = []; // Lepesek tomb

		// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

		// Tabla bejarasa
		for (var from_index = 0; from_index < 128; from_index++)
		{
			if (CHESS_BOARD[from_index] && (CHESS_BOARD[from_index] & 0x8) === currentPlayer) // AKI EPP LEPHET
			{
				for (var next_index = 0; next_index < 128; next_index++)
				{
					if (isPseudoLegal(from_index, next_index, currentPlayer))
					{
						var Score = 0; // Lepes pont

						if (CHESS_BOARD[next_index] && (CHESS_BOARD[next_index] & 0x8) !== currentPlayer) { // Ha ellenfelet tudunk leutni

							var toPiece = captureMat[CHESS_BOARD[next_index] & 0x07];
							var fromPiece = captureMat[CHESS_BOARD[from_index] & 0x07];

							Score = 9 + (toPiece - fromPiece); // 9 + kulonbseg

						} else if ((CHESS_BOARD[from_index] & 0x07) === PAWN) { // EN passant lepes

							if (next_index === EN_PASSANT)  { // En Passant lepes
								Score = 9;
							}
						}
								
						if (Score > 0) { // Ha volt utes
							AllMoves.push((((from_index << 8) | next_index) << 6) | Score);  // 22 biten taroljuk a lepest
						}
					}
				}
			}
		}

			// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			// Rendezes lepes szint szerint
			AllMoves.sort(function(a, b) {
				var a_elem = a & 0x3F; // lepes szint a elem
				var b_elem = b & 0x3F; // lepes szint b elem
				return a_elem == b_elem ? 0 : a_elem > b_elem ? -1 : 1;
			});

			return AllMoves;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	function Quiescence(alpha, beta) {

		nodes++;
		var Score = Evaluation(); // Allapot ertekelese
		var Stand_pat = Score;

		if(Score >= beta) { // Vagas
			return beta;
		}

		if(Score > alpha) { // Alpha ertek mentese
			alpha = Score;
		}

		Score = -maxEval;
		var AllMoves = GenerateCaptures(); // Utes lepesek

		if (AllMoves.length > 0)
		{
			for (var i = 0; i < AllMoves.length; i++)
			{
				var FROM_SQUARE = (AllMoves[i] >> 14) & 0xFF;
				var NEXT_SQUARE = (AllMoves[i] >> 6) & 0xFF;

				var stateData = makeMove(FROM_SQUARE, NEXT_SQUARE); // Lepes ervenyesitese

				var kingPos = ((kingPosition >> (currentPlayer ? 0 : 8)) & 0xFF); // Sajat kiraly

				if (isSquareUnderAttack(kingPos, (currentPlayer ? 0 : 8), false)) { // Nem ervenyes a lepes, ezert visszavonjuk
					unMakeMove(FROM_SQUARE, NEXT_SQUARE, stateData);
					continue;
				}

				Score = -Quiescence(-beta, -alpha); // Lepes kiertekelese

				unMakeMove(FROM_SQUARE, NEXT_SQUARE, stateData); // Lepes visszavonasa

				if (timeStop === true) { // Ido vagas
					return 0;
				}

				if (Score >= beta) { // Beta Vagas
					return beta;
				} 

				if (Score > alpha) { // Alpha ertek mentese
					alpha = Score;
				}
			}
		}

		return alpha;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	// Lepes kereses
	function AlphaBeta(alpha, beta, Depth, MaxDepth, worker, firstMove, nullMove) {

		if (Depth > 0)
		{
			nodes++;
			var Score = -maxEval;
			var kingPos = ((kingPosition >> currentPlayer) & 0xFF);
			var inCheck = isSquareUnderAttack(kingPos, currentPlayer, true); // Sakk? + Anyag ertek szamolas >> , true);

			if(inCheck) { // Sakk vonal tamogatasa
				Depth++;
			}

			// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			if (!inCheck && Depth < 2 && (Math.abs(beta - 1) > -maxEval+100)) { // Statikus null lepes metszes
				var static_eval = Evaluation();
				var eval_margin = 120 * Depth;

				if (static_eval - eval_margin >= beta) { // Ertek Vagas
					return static_eval - eval_margin;
				}
			}

			// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			if (!inCheck && nullMove && Depth > 1 && nullPieceValue[currentPlayer/8] > 20200) // Null lepes metszes
			{
				var R = (nullPieceValue[currentPlayer/8] > 20800 && Depth > 3) ? 4 : 3;

				currentPlayer = currentPlayer ? 0 : 8; // ember valtas

				var enPassant = EN_PASSANT; // En passant bug fix
				EN_PASSANT = 0; // En passant kikapcsolasa

				Score = -AlphaBeta(-beta, -beta+1, Depth-R, MaxDepth, worker, false, false); // Null Lepes

				EN_PASSANT = enPassant; // En passant vissza

				currentPlayer = currentPlayer ? 0 : 8; // ember valtas vissza

				if (timeStop === true) { // Ido vagas
					return 0;
				}

				if(Score >= beta) { // Beta Vagas
					return beta;
				}
			}

			// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			Score = -maxEval;
			var ValidMove = false; // Sikeres lepes?
			var MoveTime = ((new Date()).getTime() - g_startTime); // Kereses ideje
			var AllMoves = firstMove ? GenerateAllMoves(true) : GenerateAllMoves(false); // Lehetseges lepesek

			if (worker && (MoveTime % 1000) < 100) { // Keresesi ido frissites Worker eseten
				postMessage(["Message", 'T&uuml;relem, gondolkodok... ('
				+Math.round(maxSearchTime/1000)+'/'+Math.round(MoveTime/1000)+' mp, M&eacute;lys&eacute;g '+MaxDepth+')']);
			}

			if (MoveTime > maxSearchTime && bestMove) { // Ido vagas BE
				timeStop = true;
			}

			// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			if (AllMoves.length > 0)
			{
				for (var i = 0; i < AllMoves.length; i++)
				{
					var FROM_SQUARE = (AllMoves[i] >> 24) & 0xFF;
					var NEXT_SQUARE = (AllMoves[i] >> 16) & 0xFF;

					if (!bestMove && firstMove) { // A legelso lepest mentjuk vesz esetere
						bestMove = AllMoves[i];
					}

					var stateData = makeMove(FROM_SQUARE, NEXT_SQUARE); // Lepes ervenyesitese

					var kingPos = ((kingPosition >> (currentPlayer ? 0 : 8)) & 0xFF); // Sajat kiraly

					if (isSquareUnderAttack(kingPos, (currentPlayer ? 0 : 8), false)) { // Nem ervenyes a lepes, ezert visszavonjuk
						unMakeMove(FROM_SQUARE, NEXT_SQUARE, stateData);
						continue;
					}

					ValidMove = true; // Van ervenyes lepesunk az adott melysegben

					Score = -AlphaBeta(-beta, -alpha, Depth-1, MaxDepth, worker, false, true); // Ellenfel lepese

					unMakeMove(FROM_SQUARE, NEXT_SQUARE, stateData); // Lepes visszavonasa

					if (timeStop === true) { // Ido vagas
						return 0;
					}

					if (Score >= beta) { // Beta vagas

						if (CHESS_BOARD[NEXT_SQUARE] == 0) { // Elozmeny tabla es Gyilkos heurisztika
							historyTable[CHESS_BOARD[FROM_SQUARE]][NEXT_SQUARE] += Depth;
							searchKillers[64 + boardPly] = searchKillers[boardPly];
							searchKillers[boardPly] = ((CHESS_BOARD[FROM_SQUARE] << 4) | NEXT_SQUARE);
						}

						return beta;
					}

					if (Score > alpha) { // Alpha ertek mentese

						if (firstMove) bestMove = AllMoves[i]; // A legjobb lepes

						alpha = Score;
					}
				}
			}

			// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			if (! ValidMove)
			{
				// console.log((inCheck ? "SAKK" : "PATT")+' MIATT VESZITE'+((firstMove || Depth == 1) ? "TT" : "NE")+
				// ' EBBEN A MELYSEGBEN! V2 >>>> Kiraly: '+kingPos+' Depth: '+Depth+' NullMove: '+nullMove);
				// postMessage(["Redraw", CHESS_BOARD]);
				// for (var i = 0; i < 1000000000; i++) { }

				if (inCheck)
				return -maxEval + boardPly; // Matt
				else
				return 0; // Patt
			}

			return alpha;
		}
		else if (Depth <= 0)
		{
			// return Evaluation(); // ertekeles
			return Quiescence(alpha, beta); // nyugalmi ertekeles
		}
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	// adatok frissitese a Worker szamara
	function DataUpgrade(board, player, castle, enpassant, pawnReplace, kingpos) {

		nodes = 0; // csomopont nullazas
		boardPly = 0; // lepesek nullazas
		bestMove = false; // lepes nullazas
		timeStop = false; // ido vege nullazas
		CHESS_BOARD = board; // sakk tabla
		castleRights = castle; // sancolas
		kingPosition = kingpos; // kiralyok
		EN_PASSANT = enpassant; // en passant
		currentPlayer = player; // akti lephet
		REPLACE_PIECE_TO = pawnReplace; // ember csere
		g_startTime = (new Date()).getTime(); // kezdo ido

		for(var i = 0; i < 3 * 64; i++) { // Gyilkos tabla uritese
			searchKillers[i] = 0;
		}

		for (var i = 0; i < 32; i++) { // Elozmeny tabla uritese
			historyTable[i] = new Array(128);
			for (var j = 0; j < 128; j++) {
				historyTable[i][j] = 0;
			}
		}

		return true;
	}


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	self.onmessage = function (e) {

		if (e.data[0] == "restart")
		{
			// ujrainditas
		}
		else if (e.data[0] == "search")
		{
			if (DataUpgrade(e.data[3], e.data[4], e.data[5], e.data[6], e.data[7], e.data[8]))
			{
				var help = e.data[2];
				var alpha = -maxEval;
				var beta = maxEval;
				var bestNext = -1;
				var bestFrom = -1;
				var maxDepth = 64;

				if (help) { // Segitseg maxmum 2 masodpercig
					maxSearchTime = e.data[1] > 2000 ? 2000 : e.data[1];
				} else {
					maxSearchTime = e.data[1]; // Beallitott idoig keresunk
				}

				for (var i=1; i < maxDepth && !timeStop; i++) // iterativ melyites
				{
					var Score = AlphaBeta(alpha, beta, i, i, 1, true, true); // Lepes kereses (alpha, beta, Depth, MaxDepth, worker, firstMove, nullMove)

					if (timeStop === true && bestFrom !== -1) break; // Ido vagas

					bestFrom = (bestMove >> 24) & 0xFF;
					bestNext = (bestMove >> 16) & 0xFF;

					// console.log('BestMove: '+bestFrom+'|'+bestNext+' Depth: '+i+ " Score: "+Score+" Nodes: "+nodes);

					if (Score > alpha && Score < beta) { // alpha-beta Ablak
						alpha = Score - 50;
						beta = Score + 50;

						if (alpha < -maxEval) alpha = -maxEval;
						if (beta > maxEval) beta = maxEval;
					} else if (alpha != -maxEval) { // Ha kilogunk az ablakbol..
						alpha = -maxEval;
						beta = maxEval;
						i--;
					}
				}

				postMessage(["Move", bestFrom, bestNext, help]); // (Honnan, hova, segitseg)
			}
		}

	};


// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			// Tukor tabla
			var tableMirror = [
		   119,118,117,116,115,114,113,112,		0, 0, 0, 0, 0, 0, 0, 0,
		   103,102,101,100, 99, 98, 97, 96,		0, 0, 0, 0, 0, 0, 0, 0,
			87, 86, 85, 84, 83, 82, 81, 80,		0, 0, 0, 0, 0, 0, 0, 0,
			71, 70, 69, 68, 67, 66, 65, 64,		0, 0, 0, 0, 0, 0, 0, 0,
			55, 54, 53, 52, 51, 50, 49, 48,		0, 0, 0, 0, 0, 0, 0, 0,
			39, 38, 37, 36, 35, 34, 33, 32,		0, 0, 0, 0, 0, 0, 0, 0,
			23, 22, 21, 20, 19, 18, 17, 16,		0, 0, 0, 0, 0, 0, 0, 0,
			 7,  6,  5,  4,  3,  2,  1,  0
			 ];

			// Oszlop tabla
			var tableFiles = [
			 1,  2,  3,  4,  5,  6,  7,  8,		0, 0, 0, 0, 0, 0, 0, 0,
			 1,  2,  3,  4,  5,  6,  7,  8,		0, 0, 0, 0, 0, 0, 0, 0,
			 1,  2,  3,  4,  5,  6,  7,  8,		0, 0, 0, 0, 0, 0, 0, 0,
			 1,  2,  3,  4,  5,  6,  7,  8,		0, 0, 0, 0, 0, 0, 0, 0,
			 1,  2,  3,  4,  5,  6,  7,  8,		0, 0, 0, 0, 0, 0, 0, 0,
			 1,  2,  3,  4,  5,  6,  7,  8,		0, 0, 0, 0, 0, 0, 0, 0,
			 1,  2,  3,  4,  5,  6,  7,  8,		0, 0, 0, 0, 0, 0, 0, 0,
			 1,  2,  3,  4,  5,  6,  7,  8
			 ];

			// Sor tabla
			var tableRanks = [
			 0,  0,  0,  0,  0,  0,  0,  0,		0, 0, 0, 0, 0, 0, 0, 0,
			 1,  1,  1,  1,  1,  1,  1,  1,		0, 0, 0, 0, 0, 0, 0, 0,
			 2,  2,  2,  2,  2,  2,  2,  2,		0, 0, 0, 0, 0, 0, 0, 0,
			 3,  3,  3,  3,  3,  3,  3,  3,		0, 0, 0, 0, 0, 0, 0, 0,
			 4,  4,  4,  4,  4,  4,  4,  4,		0, 0, 0, 0, 0, 0, 0, 0,
			 5,  5,  5,  5,  5,  5,  5,  5,		0, 0, 0, 0, 0, 0, 0, 0,
			 6,  6,  6,  6,  6,  6,  6,  6,		0, 0, 0, 0, 0, 0, 0, 0,
			 7,  7,  7,  7,  7,  7,  7,  7
			 ];

			// king middle game
			var kingMask = [
			-70,-70,-70,-70,-70,-70,-70,-70,	0, 0, 0, 0, 0, 0, 0, 0,
			-70,-70,-70,-70,-70,-70,-70,-70,	0, 0, 0, 0, 0, 0, 0, 0,
			-70,-70,-70,-70,-70,-70,-70,-70,	0, 0, 0, 0, 0, 0, 0, 0,
			-70,-70,-70,-70,-70,-70,-70,-70,	0, 0, 0, 0, 0, 0, 0, 0,
			-70,-70,-70,-70,-70,-70,-70,-70,	0, 0, 0, 0, 0, 0, 0, 0,
			-50,-50,-50,-50,-50,-50,-50,-50,	0, 0, 0, 0, 0, 0, 0, 0,
			-30,-30,-30,-30,-30,-30,-30,-30,	0, 0, 0, 0, 0, 0, 0, 0,
			  5, 10,  0,-10,-10,  5,  5,  0
			];

			// king end game
			var kingEndMask = [
			-50,-10,  0,  0,  0,  0,-10,-50,	0, 0, 0, 0, 0, 0, 0, 0,
			-10,  0, 10, 10, 10, 10,  0,-10,	0, 0, 0, 0, 0, 0, 0, 0,
			  0, 10, 20, 20, 20, 20, 10,  0,	0, 0, 0, 0, 0, 0, 0, 0,
			  0, 10, 20, 40, 40, 20, 10,  0,	0, 0, 0, 0, 0, 0, 0, 0,
			  0, 10, 20, 40, 40, 20, 10,  0,	0, 0, 0, 0, 0, 0, 0, 0,
			  0, 10, 20, 20, 20, 20, 10,  0,	0, 0, 0, 0, 0, 0, 0, 0,
			-10,  0, 10, 10, 10, 10,  0,-10,	0, 0, 0, 0, 0, 0, 0, 0,
			-50,-10,  0,  0,  0,  0,-10,-50	
			];

			// queen
			var queenMask = [
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			25,	25,	25,	25,	25,	25,	25,	25,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0		
			];

			// rook
			var rookMask = [
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			25,	25,	25,	25,	25,	25,	25,	25,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0		
			];

			// bishop
			var bishopMask = [
			0,	0,	0,	0,	0,	0,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	0,	10,	10,	0,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	10,	15,	15,	10,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	10,	15,	20,	20,	15,	10,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	10,	15,	20,	20,	15,	10,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	10,	15,	15,	10,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	0,	10,	10,	0,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,-10,	0,	0,-10,	0,	0
			];

			// knight
			var knightMask = [
			0,	0,	0,	0,	0,	0,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	5,	10,	10,	5,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			5,	10,	10,	20,	20,	10,	10,	5,		0, 0, 0, 0, 0, 0, 0, 0,
			5,	10,	15,	20,	20,	15,	10,	5,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	10,	20,	20,	10,	5,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	10,	10,	10,	10,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	0,	5,	5,	0,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			0,-10,	0,	0,	0,	0,-10,	0
			];

			// pawn middle game
			var pawnMask = [
			0,	0,	0,	0,	0,	0,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			20,	20,	20,	30,	30,	20,	20,	20,		0, 0, 0, 0, 0, 0, 0, 0,
			10,	10,	10,	20,	20,	10,	10,	10,		0, 0, 0, 0, 0, 0, 0, 0,
			5,	5,	5,	10,	10,	5,	5,	5,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	10,	20,	20,	10,	0,	0,		0, 0, 0, 0, 0, 0, 0, 0,
			5,	0,	0,	5,	5,	0,	0,	5,		0, 0, 0, 0, 0, 0, 0, 0,
			10,	10,	0,-10,-10,	0,	10,	10,		0, 0, 0, 0, 0, 0, 0, 0,
			0,	0,	0,	0,	0,	0,	0,	0	
			 ];
